size = 36
gap = 10
y = 40
ogap = 20
settings = {["x"]=300, ["y"]=100}

Win = Turbine.UI.Lotro.Window()
Win:SetSize((size+gap)*4 - gap + 2*ogap, size + 2*gap)
Win:SetPosition(300,100) --FIX: Save position?
Win:SetVisible(true);
Win:SetText("Fishing");
Win:SetHideF12(true);
Win:SetCloseEsc(true);

qslots = {"weapon","shield", "rod","fish"}
Qslot = {}
for i,qs in pairs(qslots) do
   if qs=="fish" then
      Qslot[qs] = Turbine.UI.Lotro.Quickslot()
   else
      Qslot[qs] = Turbine.UI.Lotro.ItemControl()
   end
   Qslot[qs]:SetParent(Win)
   Qslot[qs]:SetSize(size,size)
   Qslot[qs]:SetAllowDrop(true)
   Qslot[qs]:SetBackColor(Turbine.UI.Color(0,0,0))
   local x = ogap + (i-1)*(size+gap)
   if qs=="shield" then x = x - gap/2 end
   Qslot[qs]:SetPosition(x , y)
   Qslot[qs]:SetVisible(true)
--   Qslot[qs].DragDrop = function(sender,args)
--      local shortcut = sender:GetShortcut()
--      local itemType = shortcut:GetType()
--      local itemData = shortcut:GetData()
--      print("type="..itemType)
--      print("data="..itemData)
--   end
end
local fishing = Turbine.UI.Lotro.Shortcut(9,"0x7000EE1E");
Qslot.fish:SetShortcut(fishing);

cursorY = y+size+gap/2
Cursor = Turbine.UI.Control()
Cursor:SetParent(Win)
Cursor:SetSize(size,gap/2)
Cursor:SetPosition(size+gap,cursorY)
--Cursor:SetBackColor(Turbine.UI.Color(1,0,0))
Cursor:SetVisible(true)

function QSetItem(qslot, item)
   qslot:SetShortcut(
      Turbine.UI.Lotro.Shortcut(
         Turbine.UI.Lotro.ShortcutType.Item,
         item)
   )
end
      
function SetCursor(mode,hasShield)
   local width
   local x
   local color
   local white = Turbine.UI.Color(0xAB/0xFF, 0x99/0xFF, 0x16/0xFF) 
   local black = Turbine.UI.Color(0,0,0)
   local rodcolor, othercolor
   local backs = {1,1}
   if (mode==1) then --weapon
      color = Turbine.UI.Color(1,0,0)
      x = ogap
      width = 2*size+gap
      rodcolor = white
      othercolor = black
   else
      color = Turbine.UI.Color(0,0,1)
      x = ogap + 2*size+2*gap
      width = size
      rodcolor = black
      othercolor = white
   end
   Cursor:SetBackColor(color)
   Cursor:SetSize(width,gap/2)
   Cursor:SetPosition(x,cursorY)
   Qslot.weapon:SetBackColor(othercolor)
   Qslot.rod:SetBackColor(rodcolor)
   Qslot.fish:SetBackColor(othercolor)
   if Qslot.shield:GetItem() ~= nil and not hasShield then --the QS knows about a shield but none is equipped
      Qslot.shield:SetBackColor(white)
   else
      Qslot.shield:SetBackColor(black)
   end
end
